PROGRAM gsvmsg;
USES
    os2def,os2base,os2pmapi,sysutils;

VAR
    Anchor:HAB;
    mq       :HMQ;
    msg      :QMSG;

FUNCTION  GetTask(SearchName:String):hwnd;
CONST
    ProgType:ARRAY[0..7] OF String=('DEF','FUL','VIO/W','PM',
                                    'VDM','???','???','VDM/W');
    MaxTaskCount=1024;

TYPE
    SwBlockArray=RECORD
        Count:ULong;
        Entry:ARRAY[1..MaxTaskCount] OF SwEntry;
    END;
VAR
    AllTaskList:LONGINT;
    i:INTEGER;
    SwAry:SwBlockArray;
    SwCtl:SwCntrl;
    hs:HSwitch;
    St:string;

BEGIN
    GetTask:=NullHandle;
    AllTaskList:=WinQuerySwitchList(Anchor,
                                  PSWBLOCK(@SwAry),
                                  SizeOf(SwBlockArray));
    FOR i:=1 TO AllTaskList DO BEGIN
        SwCtl:=SwAry.Entry[i].swctl;
        IF (SwCtl.uchVisibility=SWL_VISIBLE)
          AND (SwCtl.idProcess<>0) THEN BEGIN
            IF SwCtl.bProgType>7 THEN
                St:='???'
            ELSE
                st:=ProgType[SwCtl.bProgType];
            IF (pos(SearchName,StrPas(pChar(@SwCtl.szSwtitle[0])))>0 )
                AND (St='PM') THEN
            BEGIN
                GetTask:=SwCtl.hWnd;
                EXIT;
            END;
        END;
    END;
END;

PROCEDURE SendDropMsg(DropStr:string;hwndTarget:hwnd);
CONST
  DRAG_METHOD   = 'DRM_OS2FILE';
  DRAG_FORMAT   = 'DRF_UNKNOWN';
  DRAG_RMF      = '<'+DRAG_METHOD+','+DRAG_FORMAT+'>';
  IDB_UP=12003;
VAR
    diItem      : DRAGITEM;
    pdiDrag     :pDragInfo;
    DirName,FileName:String;
    FUNCTION isRoot:BOOLEAN;
    BEGIN
        result:=((Length(DropStr)<=3) AND (pos(':',DropStr)>0));
    END;
    FUNCTION isDrectroy:BOOLEAN;
    BEGIN
    END;
BEGIN
    IF isRoot THEN BEGIN
        DirName:=DropStr;
        FileName:='';
    END
    ELSE IF (FileGetAttr(DropStr) AND faDirectory)>0 THEN BEGIN
        DirName:=DropStr;
        FileName:='';
    END
    ELSE BEGIN
        DirName:=ExtractFilePath(DropStr);
        FileName:=ExtractFileName(DropStr);
    END;
    DirName:=DirName+#0;
    FileName:=FileName+#0;

    pdiDrag := DrgAllocDraginfo(1);
    pdiDrag^.hwndSource := NullHandle;

    diItem.hwndItem := NullHandle;
    diItem.ulItemID := 1;
    diItem.hstrType := DrgAddStrHandle(DRT_TEXT);
    diItem.hstrRMF := DrgAddStrHandle(DRAG_RMF);
    System.Delete(DirName,Length(DirName),1);
    diItem.hstrContainerName := DrgAddStrHandle(@DirName[1]);
    diItem.hstrSourceName := DrgAddStrHandle(@FileName[1]);

    diItem.hstrTargetName := diItem.hstrSourceName;
    diItem.cxOffset := 0;
    diItem.cyOffset := 0;
    diItem.fsControl := 0;
    diItem.fsSupportedOps := DO_MOVEABLE;

    DrgSetDragitem(pdiDrag^,
                   diItem,
                   sizeof(diItem),
                   0);

    WinPostMsg(hwndTarget,DM_DROP,MPFROMP(pdiDrag),0);
END;
VAR
st:string;
BEGIN
    Anchor:=WinInitialize(0);
    IF Anchor=0 THEN HALT(-1);
    IF GetTask('GSV:') <>NullHandle THEN BEGIN
        IF ParamCount<1 THEN BEGIN
            WRITELN(' enough Argument');
        END
        ELSE BEGIN
            WRITELN('arg =',ParamStr(1) );
            SendDropMsg(ParamStr(1),GetTask('GSV:') );
            READLN(st);
        END;
    END;
END.
